
/***************************************************************************
                 module classe va_vor_ene.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 9, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{/*	1	from	va_dynadv_cen2		1  i    j    k    t
	2	from	zwxyz_vor_ene		3  i-1  j    k    t
	3	from	zwxyz_vor_ene		3  i    j    k    t
	4	from	zwxyz_vor_ene		1  i-1  j    k    t
	5	from	zwxyz_vor_ene		1  i-1  j+1  k    t
	6	from	zwxyz_vor_ene		1  i    j    k    t
	7	from	zwxyz_vor_ene		1  i    j+1  k    t*/
  if(Yt==TU)
    YS1=0.;
  else{
    double zfact2=0.5*0.5;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
      double zx1=x4+x5;
      double zx2=x6+x7;
      YS1=x1-zfact2/e2v(Yi,Yj)*(x2*zx1+x3*zx2);
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;   YJ1I6=0.;   YJ1I7=0.;
  if(Yt!=TU){  
    double zfact2=0.5*0.5;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;   YJ1I6=0.;   YJ1I7=0.;
    }
    else{
      double zx1=x4+x5;
      double zx2=x6+x7;

      YJ1I1=1.;
      YJ1I2=-zfact2/e2v(Yi,Yj)*zx1;
      YJ1I3=-zfact2/e2v(Yi,Yj)*zx2;
      YJ1I4=-zfact2/e2v(Yi,Yj)*x2;
      YJ1I5=-zfact2/e2v(Yi,Yj)*x2;
      YJ1I6=-zfact2/e2v(Yi,Yj)*x3;
      YJ1I7=-zfact2/e2v(Yi,Yj)*x3;
    }
  }
  //  
  
}

//===========================================================================
//************************ FIN DU MODULE va_vor_ene *************************
