
/***************************************************************************
                 module classe zhpij_dyn_hpg_zco.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 17, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7,YREAL x8)
{ /*	1	from	rhd			1  i+1 	j    k    t
	2	from	rhd			1  i 	j+1  k    t
	3	from	rhd			1  i 	j    k    t
	4	from	rhd			1  i+1 	j    k-1  t
	5	from	rhd			1  i 	j+1  k-1  t
	6	from	rhd			1  i 	j    k-1  t
	7	from	zhpij_dyn_hpg_zco	1  i 	j    k-1  t
	8	from	zhpij_dyn_hpg_zco	2  i 	j    k-1  t*/

  /* YS1 */
  /*     A 3.543246415491029e-08
	 R 3.489563037431924e-07*/
  /* YS2 */
  /*     A 4.126438261507486e-08
	 R 3.318177645528311e-07*/
  if(Yt==TU)
    YS1=0.;
  else{
    double zcoef0 = - grav * 0.5;
    double zcoef1 = zcoef0 * fse3w(Yi,Yj,Yk);
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
      YS2=0.;
    }
    else{
      if(Yk==0){
	YS1=zcoef1*(x1 - x3)/ e1u(Yi,Yj);
	YS2=zcoef1*(x2 - x3)/ e2v(Yi,Yj);
      }
      else{
	YS1=x7+zcoef1*((x1+x4)-(x3+x6)) / e1u(Yi,Yj);
	YS2=x8+zcoef1*((x2+x5)-(x3+x6)) / e2v(Yi,Yj);
      }
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6,YREAL x7,YREAL x8)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;    YJ1I6=0.;   YJ1I7=0.;     YJ1I8=0.; 
  YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;   YJ2I4=0.;     YJ2I5=0.;    YJ2I6=0.;   YJ2I7=0.;     YJ2I8=0.; 
  if(Yt!=TU){  
    double zcoef0 = - grav * 0.5;
    double zcoef1 = zcoef0 * fse3w(Yi,Yj,Yk);
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.;    YJ1I6=0.;   YJ1I7=0.;     YJ1I8=0.; 
      YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;   YJ2I4=0.;     YJ2I5=0.;    YJ2I6=0.;   YJ2I7=0.;     YJ2I8=0.; 
    }
    else{
      if(Yk==0){
	YJ1I1= zcoef1/ e1u(Yi,Yj);
	YJ1I3=-zcoef1/ e1u(Yi,Yj);
	YJ2I2= zcoef1/ e2v(Yi,Yj);
	YJ2I3=-zcoef1/ e2v(Yi,Yj);
      }
      else{
	YJ1I1=  zcoef1 / e1u(Yi,Yj); 
	YJ1I3= -zcoef1 / e1u(Yi,Yj);
	YJ1I4=  zcoef1 / e1u(Yi,Yj); 
	YJ1I6= -zcoef1 / e1u(Yi,Yj);
	YJ1I7=1.;

	YJ2I2=  zcoef1/ e2v(Yi,Yj);
	YJ2I3= -zcoef1/ e2v(Yi,Yj);
	YJ2I5=  zcoef1/ e2v(Yi,Yj);
	YJ2I6= -zcoef1/ e2v(Yi,Yj);
	YJ2I8=1.; 
      }
    }
  }
  //  
}

//===========================================================================
//*******************  FIN DU MODULE zhpij_dyn_hpg_zco  *********************

